  $ . "$TESTDIR/helpers.bash"

  $ mkdir script.o
  $ echo 'mov r1, r1' > script.as
  $ asm script
  error opening script.o: Is a directory
  [1]
  $ rmdir script.o

  $ compile <<EOF
  > mov r1, r4 mov r1, r2
  > jmp r1, r2
  > stop r1
  > EOF
  syntax error, line 1: 'mov' instruction needs two operands
  syntax error, line 2: 'jmp' instruction needs one operand
  syntax error, line 3: 'stop' instruction needs no operands
  no code generated for script.as, found 3 error(s)
  no .o file
  no .ext file
  no .ent file
  [1]

  $ compile <<EOF
  > mov #5, r2
  > notaninstruction r1, r2
  > mov #5, r2
  > foo: notaninstruction r1, r2
  > EOF
  syntax error, line 2: unrecognized statement, expected one of: comment, .data, .string, instruction
  syntax error, line 4: unrecognized statement, expected one of: comment, .data, .string, instruction
  no code generated for script.as, found 2 error(s)
  no .o file
  no .ext file
  no .ent file
  [1]

  $ compile <<EOF
  > .data: mov r1, r1
  > .string "abc
  > .entry 123
  > .extern 123
  > EOF
  syntax error, line 1: expected comma separated list of numbers after .data
  syntax error, line 2: newline in quoted string
  syntax error, line 2: expected a quoted string after .string
  syntax error, line 3: expected a label after .entry
  syntax error, line 4: expected a label after .extern
  no code generated for script.as, found 5 error(s)
  no .o file
  no .ext file
  no .ent file
  [1]

  $ compile <<EOF
  > .extern foo
  > bar: mov r1, r1
  > mov ~(foo, bar), r1
  > mov ~(bar, foo), r1
  > mov ~(foo, foo), r1
  > EOF
  error: external label 'foo' cannot be used in ~(a, b) dist addressing
  error: external label 'foo' cannot be used in ~(a, b) dist addressing
  error: external label 'foo' cannot be used in ~(a, b) dist addressing
  error: external label 'foo' cannot be used in ~(a, b) dist addressing
  no code generated for script.as, found 4 error(s)
  no .o file
  no .ext file
  no .ent file
  [1]

  $ compile <<EOF
  > not #5
  > EOF
  syntax error, line 1: invalid addressing immediate for instruction not
  no code generated for script.as, found 1 error(s)
  no .o file
  no .ext file
  no .ent file
  [1]
