  $ . "$TESTDIR/helpers.bash"

  $ compile <<EOF
  > mov r1, r4
  > mov #5, r2
  > inc r1
  > EOF
  7 0
  64 83c
  65 090
  66 80c
  67 014
  68 008
  69 5cc
  6a 004
  reading 7 instructions
  (000) <100 0x64>:     10      0000       11         11         00    (reading an operand)
                      2 args     mov    iregister  iregister     A
  
  (001) <101 0x65>:     00001      00100    00
                          r1         r4     A
  
  (002) <102 0x66>:     10      0000       00         11         00    (reading two operands)
                      2 args     mov    immediate  iregister     A
  
  (003) <103 0x67>:     0000000101 00    A
  (004) <104 0x68>:     00000      00010    00
                         ----        r2     A
  
  (005) <105 0x69>:     01      0111       00         11         00    (reading an operand)
                      1 args     inc       ----    iregister     A
  
  (006) <106 0x6a>:     00000      00001    00
                         ----        r1     A
  reading 0 data
  no .ext file
  no .ent file

  $ compile <<EOF
  > mov r1, #5
  > EOF
  syntax error, line 1: invalid addressing immediate for instruction mov
  no code generated for script.as, found 1 error(s)
  no .o file
  no .ext file
  no .ent file
  [1]

  $ compile <<EOF
  > foo: mov r1, r4
  > mov foo, r1
  > EOF
  5 0
  64 83c
  65 090
  66 81c
  67 192
  68 004
  reading 5 instructions
  (000) <100 0x64>:     10      0000       11         11         00    (reading an operand)
                      2 args     mov    iregister  iregister     A
  
  (001) <101 0x65>:     00001      00100    00
                          r1         r4     A
  
  (002) <102 0x66>:     10      0000       01         11         00    (reading two operands)
                      2 args     mov      direct   iregister     A
  
  (003) <103 0x67>:     0001100100 10    R
  (004) <104 0x68>:     00000      00001    00
                         ----        r1     A
  reading 0 data
  no .ext file
  no .ent file

  $ compile <<EOF
  > ; a comment
  > EOF
  0 0
  reading 0 instructions
  reading 0 data
  no .ext file
  no .ent file

  $ compile <<EOF
  > foo: mov #5, r1
  > foo: mov #5, r1
  > mov r1, #5
  > EOF
  syntax error, line 2: redefinition of label 'foo'
  syntax error, line 3: invalid addressing immediate for instruction mov
  no code generated for script.as, found 2 error(s)
  no .o file
  no .ext file
  no .ent file
  [1]

  $ compile <<EOF
  > str: .string "abcdef"
  > add r2, str
  > EOF
  3 7
  64 8b4
  65 100
  66 19e
  67 061
  68 062
  69 063
  6a 064
  6b 065
  6c 066
  6d 000
  reading 3 instructions
  (000) <100 0x64>:     10      0010       11         01         00    (reading two operands)
                      2 args     add    iregister    direct      A
  
  (001) <101 0x65>:     00010      00000    00
                          r2        ----    A
  (002) <102 0x66>:     0001100111 10    R
  reading 7 data
  (003) 0b0001100111 <103 0x67>:   97      'a'
  (004) 0b0001101000 <104 0x68>:   98      'b'
  (005) 0b0001101001 <105 0x69>:   99      'c'
  (006) 0b0001101010 <106 0x6a>:   100     'd'
  (007) 0b0001101011 <107 0x6b>:   101     'e'
  (008) 0b0001101100 <108 0x6c>:   102     'f'
  (009) 0b0001101101 <109 0x6d>:   0       \0
  no .ext file
  no .ent file

  $ compile <<EOF
  > mov ~(a, b), r1
  > a: inc r1
  > EOF
  error: label 'b' not declared in file
  no code generated for script.as, found 1 error(s)
  no .o file
  no .ext file
  no .ent file
  [1]

  $ compile < "$TESTDIR/matala.as"
  14 b
  64 824
  65 078
  66 1fe
  67 8b4
  68 100
  69 1e2
  6a 644
  6b 1de
  6c 700
  6d fec
  6e 8fc
  6f 090
  70 5cc
  71 000
  72 82c
  73 050
  74 00c
  75 684
  76 1aa
  77 3c0
  78 061
  79 062
  7a 063
  7b 064
  7c 065
  7d 066
  7e 000
  7f 006
  80 ff7
  81 00f
  82 002
  reading 20 instructions
  (000) <100 0x64>:     10      0000       10         01         00    (reading two operands)
                      2 args     mov       dist      direct      A
  
  (001) <101 0x65>:     0000011110 00    A
  (002) <102 0x66>:     0001111111 10    R
  
  (003) <103 0x67>:     10      0010       11         01         00    (reading two operands)
                      2 args     add    iregister    direct      A
  
  (004) <104 0x68>:     00010      00000    00
                          r2        ----    A
  (005) <105 0x69>:     0001111000 10    R
  
  (006) <106 0x6a>:     01      1001       00         01         00    (reading an operand)
                      1 args     jmp       ----      direct      A
  
  (007) <107 0x6b>:     0001110111 10    R
  
  (008) <108 0x6c>:     01      1100       00         00         00    (reading an operand)
                      1 args     prn       ----    immediate     A
  
  (009) <109 0x6d>:     1111111011 00    A
  
  (010) <110 0x6e>:     10      0011       11         11         00    (reading an operand)
                      2 args     sub    iregister  iregister     A
  
  (011) <111 0x6f>:     00001      00100    00
                          r1         r4     A
  
  (012) <112 0x70>:     01      0111       00         11         00    (reading an operand)
                      1 args     inc       ----    iregister     A
  
  (013) <113 0x71>:     00000      00000    00
                         ----        r0     A
  
  (014) <114 0x72>:     10      0000       10         11         00    (reading two operands)
                      2 args     mov       dist    iregister     A
  
  (015) <115 0x73>:     0000010100 00    A
  (016) <116 0x74>:     00000      00011    00
                         ----        r3     A
  
  (017) <117 0x75>:     01      1010       00         01         00    (reading an operand)
                      1 args     bne       ----      direct      A
  
  (018) <118 0x76>:     0001101010 10    R
  
  (019) <119 0x77>:     00      1111       00         00         00    (reading next instruction)
                      0 args    stop       ----       ----       A
  
  reading 11 data
  (020) 0b0001111000 <120 0x78>:   97      'a'
  (021) 0b0001111001 <121 0x79>:   98      'b'
  (022) 0b0001111010 <122 0x7a>:   99      'c'
  (023) 0b0001111011 <123 0x7b>:   100     'd'
  (024) 0b0001111100 <124 0x7c>:   101     'e'
  (025) 0b0001111101 <125 0x7d>:   102     'f'
  (026) 0b0001111110 <126 0x7e>:   0       \0
  (027) 0b0001111111 <127 0x7f>:   6       '\x06'
  (028) 0b0010000000 <128 0x80>:   -9      -
  (029) 0b0010000001 <129 0x81>:   15      '\x0f'
  (030) 0b0010000010 <130 0x82>:   2       '\x02'
  no .ext file
  no .ent file


  $ compile <<EOF
  > foo: mov r1, r2
  > .entry foo
  > EOF
  2 0
  64 83c
  65 088
  reading 2 instructions
  (000) <100 0x64>:     10      0000       11         11         00    (reading an operand)
                      2 args     mov    iregister  iregister     A
  
  (001) <101 0x65>:     00001      00010    00
                          r1         r2     A
  reading 0 data
  no .ext file
  
  ent file
  --- ----
  
  foo 64

  $ compile <<EOF
  > foo: mov r1, r2
  > .entry foo
  > .entry foo
  > EOF
  2 0
  64 83c
  65 088
  reading 2 instructions
  (000) <100 0x64>:     10      0000       11         11         00    (reading an operand)
                      2 args     mov    iregister  iregister     A
  
  (001) <101 0x65>:     00001      00010    00
                          r1         r2     A
  reading 0 data
  no .ext file
  
  ent file
  --- ----
  
  foo 64

  $ compile <<EOF
  > .entry foo
  > EOF
  error: label 'foo' not declared in file
  no code generated for script.as, found 1 error(s)
  no .o file
  no .ext file
  no .ent file
  [1]

  $ compile <<EOF
  > .string "a\nb\tc"
  > .string "!@#$%^&*()-_=+~[]{};:'<>,./?"
  > EOF
  0 23
  64 061
  65 00a
  66 062
  67 009
  68 063
  69 000
  6a 021
  6b 040
  6c 023
  6d 024
  6e 025
  6f 05e
  70 026
  71 02a
  72 028
  73 029
  74 02d
  75 05f
  76 03d
  77 02b
  78 07e
  79 05b
  7a 05d
  7b 07b
  7c 07d
  7d 03b
  7e 03a
  7f 027
  80 03c
  81 03e
  82 02c
  83 02e
  84 02f
  85 03f
  86 000
  reading 0 instructions
  reading 35 data
  (000) 0b0001100100 <100 0x64>:   97      'a'
  (001) 0b0001100101 <101 0x65>:   10      '\n'
  (002) 0b0001100110 <102 0x66>:   98      'b'
  (003) 0b0001100111 <103 0x67>:   9       '\t'
  (004) 0b0001101000 <104 0x68>:   99      'c'
  (005) 0b0001101001 <105 0x69>:   0       \0
  (006) 0b0001101010 <106 0x6a>:   33      '!'
  (007) 0b0001101011 <107 0x6b>:   64      '@'
  (008) 0b0001101100 <108 0x6c>:   35      '#'
  (009) 0b0001101101 <109 0x6d>:   36      '$'
  (010) 0b0001101110 <110 0x6e>:   37      '%'
  (011) 0b0001101111 <111 0x6f>:   94      '^'
  (012) 0b0001110000 <112 0x70>:   38      '&'
  (013) 0b0001110001 <113 0x71>:   42      '*'
  (014) 0b0001110010 <114 0x72>:   40      '('
  (015) 0b0001110011 <115 0x73>:   41      ')'
  (016) 0b0001110100 <116 0x74>:   45      '-'
  (017) 0b0001110101 <117 0x75>:   95      '_'
  (018) 0b0001110110 <118 0x76>:   61      '='
  (019) 0b0001110111 <119 0x77>:   43      '+'
  (020) 0b0001111000 <120 0x78>:   126     '~'
  (021) 0b0001111001 <121 0x79>:   91      '['
  (022) 0b0001111010 <122 0x7a>:   93      ']'
  (023) 0b0001111011 <123 0x7b>:   123     '{'
  (024) 0b0001111100 <124 0x7c>:   125     '}'
  (025) 0b0001111101 <125 0x7d>:   59      ';'
  (026) 0b0001111110 <126 0x7e>:   58      ':'
  (027) 0b0001111111 <127 0x7f>:   39      "'"
  (028) 0b0010000000 <128 0x80>:   60      '<'
  (029) 0b0010000001 <129 0x81>:   62      '>'
  (030) 0b0010000010 <130 0x82>:   44      ','
  (031) 0b0010000011 <131 0x83>:   46      '.'
  (032) 0b0010000100 <132 0x84>:   47      '/'
  (033) 0b0010000101 <133 0x85>:   63      '?'
  (034) 0b0010000110 <134 0x86>:   0       \0
  no .ext file
  no .ent file
